//////////////////////////////////////////////////////////////////////
//
//  FANCYFNT.PRG
//
//  Copyright:
//      Alaska Software, (c) 1997-2009. All rights reserved.         
//  
//  Contents:
//      This sample program renders some text strings demonstrating the GRA
//      engine's GraStringAt() primitive.
//   
//////////////////////////////////////////////////////////////////////
#include "appevent.ch"
#include "xbp.ch"
#include "gra.ch"


******************************************************************************
* Main() procedure and event loop
******************************************************************************
PROCEDURE Main

   LOCAL nEvent, mp1, mp2, oObj
   LOCAL oPS
   LOCAL oFont
   LOCAL aLineAttrs
   LOCAL aStringAttrs
   LOCAL aMatrix
   LOCAL i


   /*
    * Setup XbpCrt object created by the AppSys()
    * procedure
    */
   SetAppWindow():useShortCuts := .T.
   SetColor( "N/W+" )
   CLS

   /* Get presentation space for rendering   */
   oPS := SetAppWindow():presSpace()

   oFont := XbpFont():new():create("20.Arial Bold")
   GraSetFont(oPS , oFont)                                // ⠭ 
   aAttrF := ARRAY( GRA_AS_COUNT ) 
   aAttrF [ GRA_AS_COLOR      ] := GRA_CLR_BLACK 
   aAttrF [ GRA_AS_HORIZALIGN ] := GRA_HALIGN_LEFT        // ࠢ ᨬ  ਧ⠫  業 ⭮⥫쭮 窨 砫 뢮
   aAttrF [ GRA_AS_VERTALIGN  ] := GRA_VALIGN_HALF        // ࠢ ᨬ  ⨪  ।  ⭮⥫쭮 窨 砫 뢮
   GraSetAttrString( oPS, aAttrF ) 
   GraStringAt( oPS, { 20,350 }, 'The text before the rotation' )

   /*
    * Rotate text strings to show transforms via
    * SetGraTransform()
    */
   oFont := XbpFont():new():create("10.Arial Bold")
   GraSetFont(oPS , oFont)                                // ⠭ 
   aAttrF := ARRAY( GRA_AS_COUNT ) 
   aAttrF [ GRA_AS_COLOR      ] := GRA_CLR_BLACK 
   aAttrF [ GRA_AS_HORIZALIGN ] := GRA_HALIGN_CENTER      // ࠢ ᨬ  ਧ⠫  業 ⭮⥫쭮 窨 砫 뢮
   aAttrF [ GRA_AS_VERTALIGN  ] := GRA_VALIGN_HALF        // ࠢ ᨬ  ⨪  ।  ⭮⥫쭮 窨 砫 뢮
   GraSetAttrString( oPS, aAttrF ) 

   nAngle = 10

   aMatrix := GraInitMatrix()
   FOR i:=1 TO nAngle
      GraRotate( oPS, aMatrix, 360/nAngle, {200, 200}, GRA_TRANSFORM_ADD )
      oPS:setGraTransform( aMatrix, GRA_TRANSFORM_REPLACE )
      GraStringAt( oPS, {100,100}, ALLTRIM(STR(i))+"-Rotated text..." )
   NEXT

   *****   360 ࠤᮢ

   GraRotate( oPS, aMatrix, 360, {200, 200}, GRA_TRANSFORM_ADD )
   oPS:setGraTransform( aMatrix, GRA_TRANSFORM_REPLACE )
   
   oFont := XbpFont():new():create("20.Arial Bold")
   GraSetFont(oPS , oFont)                                // ⠭ 
   aAttrF := ARRAY( GRA_AS_COUNT ) 
   aAttrF [ GRA_AS_COLOR      ] := GRA_CLR_BLACK 
   aAttrF [ GRA_AS_HORIZALIGN ] := GRA_HALIGN_LEFT        // ࠢ ᨬ  ਧ⠫  業 ⭮⥫쭮 窨 砫 뢮
   aAttrF [ GRA_AS_VERTALIGN  ] := GRA_VALIGN_HALF        // ࠢ ᨬ  ⨪  ।  ⭮⥫쭮 窨 砫 뢮
   GraSetAttrString( oPS, aAttrF ) 
   GraStringAt( oPS, { 20,50 }, 'The text after the label at an angle' )

   INKEY(0)

RETURN

// EOF